define("scarabStaticViewsApi", ["componentmodelComponentApi", "gameLayoutApi", "clientkernelEventbusApi"],
    function(componentmodelComponentApi, gameLayoutApi, clientkernelEventbusApi) {
        "use strict";

        function $iterator(o) {
            if (o instanceof Array) return function() {
                return {
                    cur: 0,
                    arr: o,
                    hasNext: function() {
                        return this.cur < this.arr.length;
                    },
                    next: function() {
                        return this.arr[this.cur++];
                    }
                };
            };
            return typeof(o.iterator) == 'function' ? $bind(o, o.iterator) : o.iterator;
        };;
        var $fid = 0;

        function $bind(o, m) {
            if (m == null) return null;
            if (m.__id__ == null) m.__id__ = $fid++;
            var f;
            if (o.hx__closures__ == null) o.hx__closures__ = {};
            else f = o.hx__closures__[m.__id__];
            if (f == null) {
                f = function() {
                    return f.method.apply(f.scope, arguments);
                };
                f.scope = o;
                f.method = m;
                o.hx__closures__[m.__id__] = f;
            }
            return f;
        };
        var $_;
        var $estr = function() {
            return _hcmn_.js_Boot.__string_rec(this, '');
        };
        if (typeof scarabStaticViewsApi == 'undefined') {
            var scarabStaticViewsApi = {};
        };
        scarabStaticViewsApi.StaticViewsDeclaration = function() {};
        scarabStaticViewsApi.StaticViewsDeclaration = ck_implements(scarabStaticViewsApi.StaticViewsDeclaration, componentmodelComponentApi.IComponentDeclaration);
        scarabStaticViewsApi.StaticViewsDeclaration.__interfaces__ = [componentmodelComponentApi.IComponentDeclaration];
        scarabStaticViewsApi.StaticViewsDeclaration.__name__ = ["scarabStaticViewsApi", "StaticViewsDeclaration"];
        scarabStaticViewsApi.StaticViewsDeclaration.prototype.getChildComponents = function() {
            return null;
        };
        scarabStaticViewsApi.StaticViewsDeclaration.prototype.getReferredComponents = function() {
            return null;
        };
        scarabStaticViewsApi.StaticViewsDeclaration.prototype.getImplementedPorts = function() {
            return [scarabStaticViewsApi.IStaticViewsImplementationPort];
        };
        scarabStaticViewsApi.StaticViewsDeclaration.prototype.getUsedPorts = function() {
            return [scarabStaticViewsApi.IStaticViewsPort, gameLayoutApi.IGameLayoutPort];
        };
        scarabStaticViewsApi.StaticViewsDeclaration.prototype.__class__ = scarabStaticViewsApi.StaticViewsDeclaration;

        scarabStaticViewsApi.IStaticViewsImplementationPort = function() {}
        scarabStaticViewsApi.IStaticViewsImplementationPort.prototype = {

            getShow: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getHide: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getDisable: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getEnable: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getChoice: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getPlayFlyAnimation: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getLayoutUpdated: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            }
        };

        scarabStaticViewsApi.IStaticViewsPort = function() {}
        scarabStaticViewsApi.IStaticViewsPort.prototype = {

            getShow: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getHide: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getEnable: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getDisable: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getChoice: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getPlayFlyAnimation: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getLayoutUpdated: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            }
        };
        scarabStaticViewsApi.StaticViewsPort = function(bus) {
            this.playFlyAnimation = new clientkernelEventbusApi.Topic("staticViews:playFlyAnimation");
            this.layoutUpdated = new clientkernelEventbusApi.Topic("staticViews:getActiveLogo");
            this.choice = new clientkernelEventbusApi.Topic("staticViews:choice");
            this.disable = new clientkernelEventbusApi.Topic("staticViews:disable");
            this.enable = new clientkernelEventbusApi.Topic("staticViews:enable");
            this.hide = new clientkernelEventbusApi.Topic("staticViews:hide");
            this.show = new clientkernelEventbusApi.Topic("staticViews:show");
            this.show.connect(bus);
            this.hide.connect(bus);
            this.choice.connect(bus);
            this.layoutUpdated.connect(bus);
            this.enable.connect(bus);
            this.disable.connect(bus);
            this.playFlyAnimation.connect(bus);
        };
        scarabStaticViewsApi.StaticViewsPort = ck_implements(scarabStaticViewsApi.StaticViewsPort, scarabStaticViewsApi.IStaticViewsPort);
        scarabStaticViewsApi.StaticViewsPort = ck_implements(scarabStaticViewsApi.StaticViewsPort, scarabStaticViewsApi.IStaticViewsImplementationPort);
        scarabStaticViewsApi.StaticViewsPort.__interfaces__ = [scarabStaticViewsApi.IStaticViewsPort, scarabStaticViewsApi.IStaticViewsImplementationPort];
        scarabStaticViewsApi.StaticViewsPort.__name__ = ["scarabStaticViewsApi", "StaticViewsPort"];
        scarabStaticViewsApi.StaticViewsPort.prototype.show = null;
        scarabStaticViewsApi.StaticViewsPort.prototype.hide = null;
        scarabStaticViewsApi.StaticViewsPort.prototype.enable = null;
        scarabStaticViewsApi.StaticViewsPort.prototype.disable = null;
        scarabStaticViewsApi.StaticViewsPort.prototype.choice = null;
        scarabStaticViewsApi.StaticViewsPort.prototype.layoutUpdated = null;
        scarabStaticViewsApi.StaticViewsPort.prototype.playFlyAnimation = null;
        scarabStaticViewsApi.StaticViewsPort.prototype.getShow = function() {
            return this.show;
        };
        scarabStaticViewsApi.StaticViewsPort.prototype.getHide = function() {
            return this.hide;
        };
        scarabStaticViewsApi.StaticViewsPort.prototype.getEnable = function() {
            return this.enable;
        };
        scarabStaticViewsApi.StaticViewsPort.prototype.getDisable = function() {
            return this.disable;
        };
        scarabStaticViewsApi.StaticViewsPort.prototype.getChoice = function() {
            return this.choice;
        };
        scarabStaticViewsApi.StaticViewsPort.prototype.getLayoutUpdated = function() {
            return this.layoutUpdated;
        };
        scarabStaticViewsApi.StaticViewsPort.prototype.getPlayFlyAnimation = function() {
            return this.playFlyAnimation;
        };
        scarabStaticViewsApi.StaticViewsPort.prototype.__class__ = scarabStaticViewsApi.StaticViewsPort;
        scarabStaticViewsApi.StaticViewsPortFactory = function() {};
        scarabStaticViewsApi.StaticViewsPortFactory = ck_implements(scarabStaticViewsApi.StaticViewsPortFactory, componentmodelComponentApi.IPortFactory);
        scarabStaticViewsApi.StaticViewsPortFactory.__interfaces__ = [componentmodelComponentApi.IPortFactory];
        scarabStaticViewsApi.StaticViewsPortFactory.__name__ = ["scarabStaticViewsApi", "StaticViewsPortFactory"];
        scarabStaticViewsApi.StaticViewsPortFactory.prototype.provide = function(channel) {
            return new scarabStaticViewsApi.StaticViewsPort(channel);
        };
        scarabStaticViewsApi.StaticViewsPortFactory.prototype["use"] = function(channel) {
            return new scarabStaticViewsApi.StaticViewsPort(channel);
        };
        scarabStaticViewsApi.StaticViewsPortFactory.prototype.__class__ = scarabStaticViewsApi.StaticViewsPortFactory;
        scarabStaticViewsApi.HideStaticViewPayload = function(type) {
            this.type = type;
        };
        scarabStaticViewsApi.HideStaticViewPayload.__name__ = ["scarabStaticViewsApi", "HideStaticViewPayload"];
        scarabStaticViewsApi.HideStaticViewPayload.prototype.type = null;
        scarabStaticViewsApi.HideStaticViewPayload.prototype.__class__ = scarabStaticViewsApi.HideStaticViewPayload;
        scarabStaticViewsApi.ShowStaticViewPayload = function(type, content) {
            this.type = type;
            this.content = content;
        };
        scarabStaticViewsApi.ShowStaticViewPayload.__name__ = ["scarabStaticViewsApi", "ShowStaticViewPayload"];
        scarabStaticViewsApi.ShowStaticViewPayload.prototype.type = null;
        scarabStaticViewsApi.ShowStaticViewPayload.prototype.content = null;
        scarabStaticViewsApi.ShowStaticViewPayload.prototype.__class__ = scarabStaticViewsApi.ShowStaticViewPayload;
        scarabStaticViewsApi.StaticViewTypeEnum = {
            __ename__: ["scarabStaticViewsApi", "StaticViewTypeEnum"],
            __constructs__: ["picker", "reel_background", "game_logo_landscape", "game_logo_portrait", "fs_summary", "fs_retrigger", "fs_award_cap", "award_cap", "award_cap_retrigger", "bonus_counter", "fs_bonus_counter", "reel_frames"]
        };
        scarabStaticViewsApi.StaticViewTypeEnum.reel_background = ["reel_background", 1];
        scarabStaticViewsApi.StaticViewTypeEnum.reel_background.toString = $estr;
        scarabStaticViewsApi.StaticViewTypeEnum.reel_background.__enum__ = scarabStaticViewsApi.StaticViewTypeEnum;
        scarabStaticViewsApi.StaticViewTypeEnum.bonus_counter = ["bonus_counter", 9];
        scarabStaticViewsApi.StaticViewTypeEnum.bonus_counter.toString = $estr;
        scarabStaticViewsApi.StaticViewTypeEnum.bonus_counter.__enum__ = scarabStaticViewsApi.StaticViewTypeEnum;
        scarabStaticViewsApi.StaticViewTypeEnum.picker = ["picker", 0];
        scarabStaticViewsApi.StaticViewTypeEnum.picker.toString = $estr;
        scarabStaticViewsApi.StaticViewTypeEnum.picker.__enum__ = scarabStaticViewsApi.StaticViewTypeEnum;
        scarabStaticViewsApi.StaticViewTypeEnum.award_cap = ["award_cap", 7];
        scarabStaticViewsApi.StaticViewTypeEnum.award_cap.toString = $estr;
        scarabStaticViewsApi.StaticViewTypeEnum.award_cap.__enum__ = scarabStaticViewsApi.StaticViewTypeEnum;
        scarabStaticViewsApi.StaticViewTypeEnum.fs_award_cap = ["fs_award_cap", 6];
        scarabStaticViewsApi.StaticViewTypeEnum.fs_award_cap.toString = $estr;
        scarabStaticViewsApi.StaticViewTypeEnum.fs_award_cap.__enum__ = scarabStaticViewsApi.StaticViewTypeEnum;
        scarabStaticViewsApi.StaticViewTypeEnum.fs_summary = ["fs_summary", 4];
        scarabStaticViewsApi.StaticViewTypeEnum.fs_summary.toString = $estr;
        scarabStaticViewsApi.StaticViewTypeEnum.fs_summary.__enum__ = scarabStaticViewsApi.StaticViewTypeEnum;
        scarabStaticViewsApi.StaticViewTypeEnum.reel_frames = ["reel_frames", 11];
        scarabStaticViewsApi.StaticViewTypeEnum.reel_frames.toString = $estr;
        scarabStaticViewsApi.StaticViewTypeEnum.reel_frames.__enum__ = scarabStaticViewsApi.StaticViewTypeEnum;
        scarabStaticViewsApi.StaticViewTypeEnum.fs_bonus_counter = ["fs_bonus_counter", 10];
        scarabStaticViewsApi.StaticViewTypeEnum.fs_bonus_counter.toString = $estr;
        scarabStaticViewsApi.StaticViewTypeEnum.fs_bonus_counter.__enum__ = scarabStaticViewsApi.StaticViewTypeEnum;
        scarabStaticViewsApi.StaticViewTypeEnum.game_logo_landscape = ["game_logo_landscape", 2];
        scarabStaticViewsApi.StaticViewTypeEnum.game_logo_landscape.toString = $estr;
        scarabStaticViewsApi.StaticViewTypeEnum.game_logo_landscape.__enum__ = scarabStaticViewsApi.StaticViewTypeEnum;
        scarabStaticViewsApi.StaticViewTypeEnum.award_cap_retrigger = ["award_cap_retrigger", 8];
        scarabStaticViewsApi.StaticViewTypeEnum.award_cap_retrigger.toString = $estr;
        scarabStaticViewsApi.StaticViewTypeEnum.award_cap_retrigger.__enum__ = scarabStaticViewsApi.StaticViewTypeEnum;
        scarabStaticViewsApi.StaticViewTypeEnum.fs_retrigger = ["fs_retrigger", 5];
        scarabStaticViewsApi.StaticViewTypeEnum.fs_retrigger.toString = $estr;
        scarabStaticViewsApi.StaticViewTypeEnum.fs_retrigger.__enum__ = scarabStaticViewsApi.StaticViewTypeEnum;
        scarabStaticViewsApi.StaticViewTypeEnum.game_logo_portrait = ["game_logo_portrait", 3];
        scarabStaticViewsApi.StaticViewTypeEnum.game_logo_portrait.toString = $estr;
        scarabStaticViewsApi.StaticViewTypeEnum.game_logo_portrait.__enum__ = scarabStaticViewsApi.StaticViewTypeEnum;
        if (typeof haxe == 'undefined') {
            var haxe = {};
        };

        haxe.IMap = function() {}
        haxe.IMap.prototype = {

        };
        return {
            exports: scarabStaticViewsApi
        };
    });
//# sourceURL=scarabStaticViewsApi.js